## obs-advanced-masks 1.1.0

=== CMakeLists.txt ===
# --- Detect if the plugin is build out of tree or not ---
if(CMAKE_PROJECT_NAME STREQUAL "obs-studio")
  set(BUILD_OUT_OF_TREE OFF)
  if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
    legacy_check()
  endif()
else()
  set(BUILD_OUT_OF_TREE ON)
  cmake_minimum_required(VERSION 3.18)
endif()

project(obs-advanced-masks VERSION 1.1.0)
set(PROJECT_FULL_NAME "Advanced Masks")

# Set new UUIDs when you start to create a new plugin.
set(MACOS_PACKAGE_UUID "7789455d-9778-42bf-9a4e-40f2a6441e45")
set(MACOS_INSTALLER_UUID "84aa3f86-fa80-481e-87c7-48c053f8fc75")

add_library(${PROJECT_NAME} MODULE)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h)

target_sources(${PROJECT_NAME} PRIVATE
	src/advanced-masks-filter.c
	src/base-filter.h
	src/color-adjustments.c
	src/color-adjustments.h
	src/obs-advanced-masks-plugin.c
	src/advanced-masks-filter.h
	src/advanced-masks.h
	src/mask-bsm.c
	src/mask-bsm.h
	src/mask-gradient.c
	src/mask-gradient.h
	src/mask-shape.c
	src/mask-shape.h
	src/mask-source.c
	src/mask-source.h
	src/obs-utils.c
	src/obs-utils.h
	src/version.h)

if(BUILD_OUT_OF_TREE)
	find_package(libobs REQUIRED)
	include(cmake/ObsPluginHelpers.cmake)
endif()
  
if(OS_WINDOWS)
	get_filename_component(ISS_FILES_DIR "${CMAKE_BINARY_DIR}\\..\\package" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_FILES_DIR}" ISS_FILES_DIR)
	get_filename_component(ISS_PACKAGE_DIR "${CMAKE_PACKAGE_PREFIX}\\.." ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_PACKAGE_DIR}" ISS_PACKAGE_DIR)
	get_filename_component(ISS_SOURCE_DIR "${PROJECT_SOURCE_DIR}" ABSOLUTE)
	file(TO_NATIVE_PATH "${ISS_SOURCE_DIR}" ISS_SOURCE_DIR)
	configure_file("installer.iss.in"
			"${PROJECT_BINARY_DIR}/installer.iss"
		)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/resource.rc.in ${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
	target_sources(${PROJECT_NAME} PRIVATE 
		${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
elseif(OS_MACOS)
		set(MACOS_BUNDLEID "com.finitesingularity.${PROJECT_NAME}")
		set(MACOSX_PLUGIN_GUI_IDENTIFIER "${MACOS_BUNDLEID}")
		set(MACOSX_PLUGIN_BUNDLE_VERSION "${PROJECT_VERSION}")
		set(MACOSX_PLUGIN_SHORT_VERSION_STRING "1")
		configure_file(cmake/bundle/macos/installer-macos.pkgproj.in ${CMAKE_BINARY_DIR}/installer-macos.generated.pkgproj)
		target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
endif()

target_link_libraries(${PROJECT_NAME}
	OBS::libobs)

if(BUILD_OUT_OF_TREE)
    if(NOT LIB_OUT_DIR)
        set(LIB_OUT_DIR "/lib/obs-plugins")
    endif()
    if(NOT DATA_OUT_DIR)
        set(DATA_OUT_DIR "/share/obs/obs-plugins/${PROJECT_NAME}")
    endif()
    set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
    install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${LIB_OUT_DIR})
    install(DIRECTORY data/locale
        DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
    setup_plugin_target(${PROJECT_NAME})
else()
    if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
        set_target_properties_obs(${PROJECT_NAME} PROPERTIES FOLDER "plugins/finitesingularity" PREFIX "")
    else()
        set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "plugins/finitesingularity")
        setup_plugin_target(${PROJECT_NAME})
    endif()
endif()

=== debian/changelog ===
obs-advanced-masks (1.1.0-3) unstable; urgency=medium

  * debian/patches/020_add-pt-BR.patch: fixed some spelling errors.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 04 Apr 2025 16:31:13 -0300

obs-advanced-masks (1.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/patches/020_add-pt-BR.patch: fixed a spelling error in Description
    field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 04 Apr 2025 00:54:04 -0300

obs-advanced-masks (1.1.0-1) experimental; urgency=medium

  * Initial release. (Closes: #1101836)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 01 Apr 2025 10:50:24 -0300

=== debian/control ===
Source: obs-advanced-masks
Section: video
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake, libobs-dev, pandoc
Standards-Version: 4.7.2
Homepage: https://obsproject.com/forum/resources/advanced-masks.1856/
Vcs-Browser: https://salsa.debian.org/debian/obs-advanced-masks
Vcs-Git: https://salsa.debian.org/debian/obs-advanced-masks.git

Package: obs-advanced-masks
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio
Enhances: obs-studio
Description: plugin for OBS Studio to apply advanced masking filters
 OBS Advanced Masks expands the masking functionalities within OBS Studio. This
 plugin provides filters for users to create intricate and customized masks for
 OBS Scenes and Sources.
 .
 Advanced Masks provides some features:
   * Both Alpha Masking and Adjustment Masking.
   * Shape masks allow for dynamically generated Rectangle, Circle, Elliptical,
     Regular Polygon, Star and Heart shaped masks, with many adjustable
     parameters.
   * Source Masks allow an existing OBS source to be used as a mask, using any
     combination of the red, green, blue, or alpha channels from said source.
   * Image Masks include all of the same functionality as Source Masks, but
     applied via a static image (.png, .jpeg, etc).
   * Gradient Masks allow a fading mask using a user-specified gradient.

## obs-advanced-masks 1.5.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
 # --- Detect if the plugin is build out of tree or not ---
 if(CMAKE_PROJECT_NAME STREQUAL "obs-studio")
   set(BUILD_OUT_OF_TREE OFF)
-  if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
-    legacy_check()
-  endif()
+#   if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
+#     legacy_check()
+#   endif()
 else()
   set(BUILD_OUT_OF_TREE ON)
   cmake_minimum_required(VERSION 3.18)
 endif()
 
-project(obs-advanced-masks VERSION 1.1.0)
+project(obs-advanced-masks VERSION 1.5.4)
 set(PROJECT_FULL_NAME "Advanced Masks")
 
 # Set new UUIDs when you start to create a new plugin.
@@ -19,6 +19,9 @@
 add_library(${PROJECT_NAME} MODULE)
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h)
+
+# Path were nlohmann_json is supposed to be installed inside the Flatpak runtime
+set(JSON_TARBALL_PATH "${CMAKE_SOURCE_DIR}/json.tar.xz")
 
 target_sources(${PROJECT_NAME} PRIVATE
 	src/advanced-masks-filter.c
@@ -30,21 +33,68 @@
 	src/advanced-masks.h
 	src/mask-bsm.c
 	src/mask-bsm.h
+	src/mask-chroma-key.c
+	src/mask-chroma-key.h
+	src/mask-feather.c
+	src/mask-feather.h
+	src/mask-font-awesome.cpp
+	src/mask-font-awesome.hpp
 	src/mask-gradient.c
 	src/mask-gradient.h
 	src/mask-shape.c
 	src/mask-shape.h
 	src/mask-source.c
 	src/mask-source.h
+	src/mask-svg.c
+	src/mask-svg.h
 	src/obs-utils.c
 	src/obs-utils.h
+	src/svg-utils.cpp
+	src/svg-utils.hpp
+	src/utils.c
+	src/utils.h
 	src/version.h)
 
 if(BUILD_OUT_OF_TREE)
-	find_package(libobs REQUIRED)
-	include(cmake/ObsPluginHelpers.cmake)
+
+    find_package(libobs REQUIRED)
+    find_package(obs-frontend-api REQUIRED)
+    include(cmake/ObsPluginHelpers.cmake)
+    find_qt(COMPONENTS Widgets Svg Xml COMPONENTS_LINUX Gui)
+    set(OBS_FRONTEND_API_NAME "obs-frontend-api")
+
+    # Check if nlohmann_json exists
+    if(EXISTS "${JSON_TARBALL_PATH}")
+        file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}")
+        execute_process(
+            COMMAND ${CMAKE_COMMAND} -E tar xJf "${JSON_TARBALL_PATH}"
+            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
+        )
+        add_library(nlohmann_json INTERFACE)
+        target_include_directories(nlohmann_json INTERFACE "${CMAKE_BINARY_DIR}/json/single_include")
+    else()
+        include(FetchContent)
+        FetchContent_Declare(json URL https://github.com/nlohmann/json/releases/download/v3.11.3/json.tar.xz)
+        FetchContent_MakeAvailable(json)
+    endif()
+else()
+	if(OBS_VERSION VERSION_GREATER_EQUAL 30.1.0)
+		find_package(Qt6 COMPONENTS Core Widgets Svg Xml)
+		# find_package(nlohmann_json REQUIRED)
+		include(FetchContent)
+		FetchContent_Declare(nlohmann_json URL https://github.com/nlohmann/json/releases/download/v3.11.3/json.tar.xz)
+		FetchContent_MakeAvailable(nlohmann_json)
+	else()
+		find_qt(COMPONENTS Widgets Svg Xml COMPONENTS_LINUX Gui)
+		if(OS_WINDOWS)
+			include(FetchContent)
+			FetchContent_Declare(nlohmann_json URL https://github.com/nlohmann/json/releases/download/v3.11.3/json.tar.xz)
+			FetchContent_MakeAvailable(nlohmann_json)
+		endif()
+	endif()
+	set(OBS_FRONTEND_API_NAME "frontend-api")
 endif()
-  
+
 if(OS_WINDOWS)
 	get_filename_component(ISS_FILES_DIR "${CMAKE_BINARY_DIR}\\..\\package" ABSOLUTE)
 	file(TO_NATIVE_PATH "${ISS_FILES_DIR}" ISS_FILES_DIR)
@@ -59,16 +109,38 @@
 	target_sources(${PROJECT_NAME} PRIVATE 
 		${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}.rc)
 elseif(OS_MACOS)
-		set(MACOS_BUNDLEID "com.finitesingularity.${PROJECT_NAME}")
-		set(MACOSX_PLUGIN_GUI_IDENTIFIER "${MACOS_BUNDLEID}")
-		set(MACOSX_PLUGIN_BUNDLE_VERSION "${PROJECT_VERSION}")
-		set(MACOSX_PLUGIN_SHORT_VERSION_STRING "1")
-		configure_file(cmake/bundle/macos/installer-macos.pkgproj.in ${CMAKE_BINARY_DIR}/installer-macos.generated.pkgproj)
-		target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
+	set(MACOS_BUNDLEID "com.finitesingularity.${PROJECT_NAME}")
+	set(MACOSX_PLUGIN_GUI_IDENTIFIER "${MACOS_BUNDLEID}")
+	set(MACOSX_PLUGIN_BUNDLE_VERSION "${PROJECT_VERSION}")
+	set(MACOSX_PLUGIN_SHORT_VERSION_STRING "1")
+	configure_file(cmake/bundle/macos/installer-macos.pkgproj.in ${CMAKE_BINARY_DIR}/installer-macos.generated.pkgproj)
+	target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
 endif()
 
-target_link_libraries(${PROJECT_NAME}
-	OBS::libobs)
+find_package(CURL REQUIRED)
+
+set_target_properties(${PROJECT_NAME} PROPERTIES AUTOMOC ON AUTOUIC ON AUTORCC ON)
+
+if(OS_MACOS)
+	target_link_libraries(${PROJECT_NAME}
+		Qt::Widgets
+		Qt::Svg
+		Qt::Xml
+		nlohmann_json
+		CURL::libcurl
+		OBS::libobs
+		OBS::${OBS_FRONTEND_API_NAME}
+		"-framework Security")
+else()
+	target_link_libraries(${PROJECT_NAME}
+		Qt::Widgets
+		Qt::Svg
+		Qt::Xml
+		nlohmann_json
+		CURL::libcurl
+		OBS::libobs
+		OBS::${OBS_FRONTEND_API_NAME})
+endif()
 
 if(BUILD_OUT_OF_TREE)
     if(NOT LIB_OUT_DIR)
@@ -80,7 +152,7 @@
     set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")
     install(TARGETS ${PROJECT_NAME}
         LIBRARY DESTINATION ${CMAKE_INSTALL_PREFIX}/${LIB_OUT_DIR})
-    install(DIRECTORY data/locale
+    install(DIRECTORY data/locale data/shaders
         DESTINATION ${CMAKE_INSTALL_PREFIX}/${DATA_OUT_DIR})
     setup_plugin_target(${PROJECT_NAME})
 else()

=== debian/changelog ===
obs-advanced-masks (1.5.4-2) unstable; urgency=medium

  * debian/control:
      - Bumped Standards-Version to 4.7.3.
      - Removed no longer needed "Priority: optional" field.
      - Removed no longer needed "Rules-Requires-Root: no" field.
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/rules: added override for blhc to ignore CMake ABI tests.
  * debian/watch: migrated to version 5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 23 Feb 2026 22:33:45 -0300

obs-advanced-masks (1.5.4-1) unstable; urgency=medium

  * New upstream version 1.5.4.
  * debian/control: added libcurl4-openssl-dev, libxkbcommon-dev,
    nlohmann-json3-dev, qt6-base-dev and qt6-svg-dev to Build-Depends field.
  * debian/patches/:
      - 010_change-project-name.patch: updated to make it compliant with the
        new upstream version.
      - 020_add-pt-BR.patch: updated the Forwarded field.
      - 030_search_nlohmann_json.patch: created to search for nlohmann_json
        path, installed via package nlohmann-json3-dev.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 04 Sep 2025 13:50:48 -0300

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,23 @@
 Source: obs-advanced-masks
 Section: video
-Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13), cmake, libobs-dev, pandoc
-Standards-Version: 4.7.2
+Build-Depends: debhelper-compat (= 13),
+               cmake,
+               libcurl4-openssl-dev,
+               libobs-dev,
+               libxkbcommon-dev,
+               nlohmann-json3-dev,
+               pandoc,
+               qt6-base-dev,
+               qt6-svg-dev
+Standards-Version: 4.7.3
 Homepage: https://obsproject.com/forum/resources/advanced-masks.1856/
 Vcs-Browser: https://salsa.debian.org/debian/obs-advanced-masks
 Vcs-Git: https://salsa.debian.org/debian/obs-advanced-masks.git
 
 Package: obs-advanced-masks
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, obs-studio
+Depends: ${misc:Depends}, ${shlibs:Depends}, obs-studio
 Enhances: obs-studio
 Description: plugin for OBS Studio to apply advanced masking filters
  OBS Advanced Masks expands the masking functionalities within OBS Studio. This

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Needed for GCC-12 and ABI issues.
# https://github.com/exeldro/obs-source-clone/issues/16
export DEB_CFLAGS_MAINT_APPEND = -Wno-psabi

# Exclude "obs-" from NAME and set a DEST
export PLUGIN_NAME=$(shell echo ${DEB_SOURCE} | cut -d"-" -f2-)
export PLUGIN_DEST=debian/${DEB_SOURCE}/usr/lib/${DEB_TARGET_MULTIARCH}/obs-plugins

%:
	dh $@

execute_before_dh_auto_configure:
	if [ "$(shell hostname)" = "canopus" ]; then \
	    LINESUS=$(shell cat data/locale/en-US.ini | wc -l); \
	    LINESPT=$(shell cat data/locale/pt-BR.ini | wc -l); \
	    if [ "$$LINESUS" != "$$LINESPT" ]; then \
	        echo "ERROR: Translation to pt_BR is out of date."; \
	        #exit 1; \
	    fi; \
	fi

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_OUT_OF_TREE=On \
                             -DLIB_OUT_DIR=lib/${DEB_TARGET_MULTIARCH}/obs-plugins \
                             -DDATA_OUT_DIR=share/obs/obs-plugins/${PLUGIN_NAME} \
                             -DLINUX_PORTABLE=Off

# blhc should ignore CMake ABI tests.
execute_before_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: /usr/bin/c\+\+ .*/Modules/CMakeCXXCompilerABI\.cpp .*'

execute_before_dh_install:
	mkdir -p ${PLUGIN_DEST}
	find -name lib${PLUGIN_NAME}.so -exec cp {} ${PLUGIN_DEST}/${PLUGIN_NAME}.so \;

execute_after_dh_installdocs:
	cd debian/${DEB_SOURCE}/usr/share/doc/${DEB_SOURCE}; \
	pandoc README.md -f markdown -t plain -o README

=== debian/watch ===
Version: 5

Template: Github
Owner: FiniteSingularity
Project: obs-advanced-masks
